// Generated by CoffeeScript 1.7.0
(function() {
  var Roots;

  Roots = require('../../lib');


  /**
   * Simple wrapper for Roots.clean, emits events and data to the cli.
   *
   * @param  {CLI} cli - event emitter for data to be piped to the cli
   * @param  {Object} args arguments object to be passed to roots fn
   * @return {Promise} a promise for the removed output
   */

  module.exports = function(cli, args) {
    var project;
    project = new Roots(args.path);
    return project.deploy(args).progress(function(msg) {
      if (typeof msg === 'string') {
        return cli.emit('info', msg);
      }
    }).then(function(res) {
      cli.emit('success', "deployment to " + res.deployer_name + " successful");
      if (res.url) {
        return cli.emit('success', res.url);
      }
    })["catch"](function(err) {
      cli.emit('err', err);
      throw err;
    });
  };

}).call(this);
